2020牛客暑期多校训练营(第六场)C.Combination of Physics and Maths

C.Combination of Physics and Maths

题目链接-C.Combination of Physics and Maths
2020牛客暑期多校训练营(第六场)C.Combination of Physics and Maths_第1张图片
2020牛客暑期多校训练营(第六场)C.Combination of Physics and Maths_第2张图片
题目大意
一个矩阵的底面积 S S S 定义为最后一行的数的和,重量 F F F定义为所有数的和。现给你一个正整数矩阵,找一个 p = F S p=\frac{F}{S} p=SF最大的可非连续子矩阵,输出 p p p的最大值

解题思路
贪 心 贪心

  • 假设 a b > c d \frac{a}{b}>\frac{c}{d} ba>dc,那么 a b − c d > 0 ⇨ a d − b c b d > 0 , 所 以 a d > c b \frac{a}{b}-\frac{c}{d}>0⇨\frac{ad-bc}{bd}>0,所以ad>cb badc>0bdadbc>0ad>cb,又 a + c b + d = a b + c b b 2 + b d , a b = a b + a d b 2 + b d \frac{a+c}{b+d}=\frac{ab+cb}{b^2+bd},\frac{a}{b}=\frac{ab+ad}{b^2+bd} b+da+c=b2+bdab+cbba=b2+bdab+ad,所以 a + c b + d < a b \frac{a+c}{b+d}<\frac{a}{b} b+da+c<ba,这样我们就能得出该矩阵单列的最大值肯定大于合并后多列的最大值,所以我们只需求出矩阵单列的最大值即可
  • 具体操作见代码

附上代码

#pragma GCC optimize("-Ofast","-funroll-all-loops")
#include
#define int long long
#define lowbit(x) (x &(-x))
#define endl '\n'
using namespace std;
const int INF=0x3f3f3f3f;
const int dir[4][2]={-1,0,1,0,0,-1,0,1};
const double PI=acos(-1.0);
const double e=exp(1.0);
const double eps=1e-10;
const int M=1e9+7;
const int N=2e5+10;
typedef long long ll;
typedef pair<int,int> PII;
typedef unsigned long long ull;
int f[250];
signed main(){
	ios::sync_with_stdio(false);
	cin.tie(0);cout.tie(0);

	int t;
	cin>>t;
	while(t--){
		int n,m;
		cin>>n>>m;
		double ans=0;
		memset(f,0,sizeof f);
		for(int i=1;i<=n;i++){
			for(int j=1;j<=m;j++){
				int tmp;
				cin>>tmp;
				f[j]+=tmp;
				ans=max(ans,1.0*f[j]/tmp);
			}
		}
		cout<<fixed<<setprecision(8)<<ans<<endl;
	}
	return 0;
}

你可能感兴趣的:(牛客nowcoder,贪心)